import cdk = require('@aws-cdk/core');
export interface SPADeployConfig {
    readonly indexDoc: string;
    readonly websiteFolder: string;
    readonly certificateARN?: string;
    readonly cfAliases?: string[];
}
export interface SPAGlobalConfig {
    readonly encryptBucket?: boolean;
    readonly ipFilter?: boolean;
    readonly ipList?: string[];
}
export declare class SPADeploy extends cdk.Construct {
    globalConfig: SPAGlobalConfig;
    constructor(scope: cdk.Construct, id: string, config?: SPAGlobalConfig);
    private getS3Bucket;
    private getCFConfig;
    /**
     * This will create an s3 deployment fronted by a cloudfront distribution
     * It will also setup error forwarding and unauth forwarding back to indexDoc
     */
    createSiteWithCloudfront(config: SPADeployConfig): void;
    /**
     * Basic setup needed for a non-ssl, non vanity url, non cached s3 website
     */
    createBasicSite(config: SPADeployConfig): void;
}
